package com.zt.plat.module.qms.business.config.service;

import java.util.*;

import com.zt.plat.module.qms.business.config.controller.vo.ConfigPermissionPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigPermissionRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigPermissionSaveReqVO;
import jakarta.validation.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigPermissionDO;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 权限配置,通用权限配置 Service 接口
 *
 * @author 后台管理
 */
public interface ConfigPermissionService {

    void savePermissionListWithAutoDelete(List<ConfigPermissionSaveReqVO> list, Long delSourceId, String delSourceType, String delPermissionType);

    void savePermission(List<ConfigPermissionDO> insertList, List<ConfigPermissionDO> updateList, List<Long> deleteList);

    void insertPermission(List<ConfigPermissionDO> insertList);

    void updatePermission(List<ConfigPermissionDO> updateList);

    void deletePermission(List<Long> deleteList);

    List<ConfigPermissionDO> getPermissionList(Long sourceId, String sourceType, String permissionType);


    /**
     * 创建权限配置,通用权限配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ConfigPermissionRespVO createConfigPermission(@Valid ConfigPermissionSaveReqVO createReqVO);

    /**
     * 更新权限配置,通用权限配置
     *
     * @param updateReqVO 更新信息
     */
    void updateConfigPermission(@Valid ConfigPermissionSaveReqVO updateReqVO);

    /**
     * 删除权限配置,通用权限配置
     *
     * @param id 编号
     */
    void deleteConfigPermission(Long id);

    /**
    * 批量删除权限配置,通用权限配置
    *
    * @param ids 编号
    */
    void deleteConfigPermissionListByIds(List<Long> ids);

    /**
     * 获得权限配置,通用权限配置
     *
     * @param id 编号
     * @return 权限配置,通用权限配置
     */
    ConfigPermissionDO getConfigPermission(Long id);

    /**
     * 获得权限配置,通用权限配置分页
     *
     * @param pageReqVO 分页查询
     * @return 权限配置,通用权限配置分页
     */
    PageResult<ConfigPermissionDO> getConfigPermissionPage(ConfigPermissionPageReqVO pageReqVO);

    /**
     * 根据目标id获取权限列表
     *
     * @param targetIds 目标id
     * @return 权限列表
     */
    List<ConfigPermissionDO> getPermissionListByTargetIds(List<Long> targetIds);
}